      SUBROUTINE BMDPAR
      INCLUDE 'STATUS'
      INCLUDE 'MODELC'
      INCLUDE 'HEADST'
       DOUBLE PRECISION BNDU,BNDL,NCOUNT
      CHARACTER LOWBND*8,UPPBND*8,LINE*68
      INTEGER VERIFY,NONBLK,NCASE,NBMDCT,LAST,I,J,JJ
      EXTERNAL VERIFY,NONBLK
      CHARACTER*1 DIGIT(0:9)
      DATA DIGIT/'0','1','2','3','4','5','6','7','8','9'/
C     SET FLAG INDICATING THAT PROC BMDPAR HAS BEEN CALLED
      BMDCAL=.TRUE.
C     INITIAL PARAMETERS AND THEIR BOUNDS
      DO 4 I=1,NPAR
         PAR(I)=0.5
         PARL(I)=0.
         PARU(I)=1.
         POINT(I)=I
         POINTL(I)=0
    4    POINTU(I)=0
      NCONS=0
      NFIX=0
      NEST=NPAR
      CALL GETCMD
    5 IF (WORDS(1).EQ.'CONSTRAINT') THEN
         INDENT=2
         CALL CONSRT(1)
      ELSE IF (WORDS(1).EQ.'INITIAL') THEN
         INDENT=2
         CALL INITAL
      ELSE IF (WORDS(1).EQ.'PROC') THEN
         GO TO 10
      ELSE
         CALL ERROR('Unrecognized command after PROC BMDPAR.')
         RETURN
      ENDIF
      GO TO 5
 10    CONTINUE
      CALL LINCHK(8)
      WRITE (UNIT=SYSOUT,FMT=
     1   '(/6X,33HNumber of parameters in model  = ,I2)') NPAR
      WRITE (UNIT=SYSOUT,FMT=
     1   '(/6X,33HNumber of parameters set equal = ,I2)') NCONS
      WRITE (UNIT=SYSOUT,FMT=
     1   '(/6X,33HNumber of parameters fixed     = ,I2)') NFIX
      WRITE (UNIT=SYSOUT,FMT=
     1   '(/6X,33HNumber of parameters estimated = ,I2)') NEST
      CALL LINCHK(7+NPAR)
      WRITE(UNIT=SYSOUT,FMT='(////31X,14HLower    Upper)')
      WRITE(UNIT=SYSOUT,FMT=
     1  '(5X,47H  I   Parameter   S(I)    Bound    Bound  Label)')
      WRITE(UNIT=SYSOUT,FMT='(6X,3H---,2X,9(1H-),2X,6(1H-),2X,
     1 1X,5(1H-),4X,5(1H-),2X,20(1H-))')
C
C   LOOP TO PRINT INITIAL CONDITIONS
C
      DO 20 I=1,NPAR
         IF (POINTL(I).GT.0) THEN
            WRITE(LOWBND,FMT='(3X,2HS(,I2.2,1H))') POINTL(I)
            BNDL=PAR(POINTL(I))
         ELSE
            WRITE(LOWBND,FMT='(F8.3)') PARL(ABS(POINT(I)))
            BNDL=PARL(ABS(POINT(I)))
         ENDIF
         IF (POINTU(I).GT.0) THEN
            WRITE(UPPBND,FMT='(3X,2HS(,I2.2,1H))') POINTU(I)
            BNDU=PAR(POINTU(I))
         ELSE
            WRITE(UPPBND,FMT='(F8.3)') PARU(ABS(POINT(I)))
            BNDU=PARU(ABS(POINT(I)))
         ENDIF
         WRITE(UNIT=SYSOUT,FMT='(5X,I3,5X,I3,3X,F8.3,1X,2(A8,1X),1X,A)')
     1      I,POINT(I),PAR(ABS(POINT(I))),LOWBND,UPPBND,SLABEL(I)
         IF (BNDL.GT.BNDU .OR. BNDL.GT.PAR(ABS(POINT(I)))
     1      .OR. BNDU.LT.PAR(ABS(POINT(I)))) THEN
            CALL WARN(
     1      'BOUNDARY ERROR -- VALUE RESET TO 0 < S(I) < 1.')
            POINTL(I)=0
            POINTU(I)=0
            PARL(ABS(POINT(I)))=0.
            PARU(ABS(POINT(I)))=1.
         ENDIF
   20    CONTINUE
C
C   DETERMINE NUMBER OF MULTINOMIAL CELLS
C
       NCASE=0
       DO 15 I=1,NCOHT
          NCASE=NCASE+NCLASS(I)
          NCOUNT=0
          DO 17 J=1,NCLASS(I)
 17          NCOUNT=NCOUNT+OBS(J,I)
          IF (NCOUNT.LT.N(I)) THEN
             NCASE=NCASE+1
          ENDIF
 15       CONTINUE
C
C   OPEN UP OUTPUT FILE FOR BMDPAR SUBROUTINE
C
      OPEN(UNIT=SYSPRG,FILE='bmdfun.f',STATUS='unknown')
      REWIND(UNIT=SYSPRG)
       WRITE(UNIT=SYSPRG,FMT='(6X,A)')
     1 'SUBROUTINE FUN(F,S,X,N,KASE,NVAR,NPAR,IPASS,XLOSS)'
       WRITE(UNIT=SYSPRG,FMT='(6X,A)')
     1 'IMPLICIT DOUBLE PRECISION (A-H,O-Z)'
      WRITE(UNIT=SYSPRG,FMT='(6X,A,I2.2,A,I2.2,1H))')
     1 'PARAMETER (MAXCHT=',MAXCHT,',MXCLAS=',MXCLAS
       WRITE(UNIT=SYSPRG,FMT='(6X,A)')
     1 'INTEGER N,KASE,NVAR,NPAR,IPASS'
       WRITE(UNIT=SYSPRG,FMT='(6X,A)')
     1 'DOUBLE PRECISION S(NPAR), X(NVAR), P(MXCLAS,MAXCHT)'
       WRITE(UNIT=SYSPRG,FMT='(6X,A)')
     1 'COMMON /MYCOMM/ P'
       WRITE(UNIT=SYSPRG,FMT='(6X,6HGO TO(,15(I3,:,1H,))')
     1  (I,I=1,MIN(15,NCASE))
      IF (NCASE.GT.15) THEN
         DO 18 I=16,NCASE,16
            WRITE(UNIT=SYSPRG,FMT='(5X,2H1,,16(I3,:,1H,))')
     1         (J,J=I,MIN(I+15,NCASE))
 18         CONTINUE
      ENDIF
      WRITE(UNIT=SYSPRG,FMT='(5X,A)') 'Z ),KASE'
      NCASE=0
      DO 22 I=1,NCOHT
         NCOUNT=0
         DO 25 J=1,NCLASS(I)
C         GET CELL PROBABILITY FOR THE (J,I) CELL FROM UNIT SYSTP1
            READ(UNIT=SYSTP1,REC=(I-1)*MXCLAS+J,FMT='(1024A1)',
     1         ERR=24) SFUNCS
            NCASE=NCASE+1
            WRITE(UNIT=SYSPRG,FMT='(1X,I3,2X,2HP(,I2,1H,,I2,2H)=,a56)')
     1            NCASE,J,I,SFUNCS(1:56)
cjeh            WRITE(UNIT=SYSPRG,FMT='(1X,I3,2X,2HP(,I2,1H,,I2,2H)=,56A1)')
cjeh     1            NCASE,J,I,(SFUNCS(JJ),JJ=1,56)
            DO 14 IB=MAXCHS,55,-1
               IF(SFUNCS(IB:IB).NE.' ') GO TO 16
cjeh               IF(SFUNCS(IB).NE.' ') GO TO 16
 14            CONTINUE
            IB=0
 16         LAST=IB
            IF (LAST.GT.56) THEN
               DO 30 JJ=57,LAST,66
                  WRITE(UNIT=SYSPRG,FMT='(5X,1H&,a66)')
     1               SFUNCS(JJ:JJ+65)
cjeh                  WRITE(UNIT=SYSPRG,FMT='(5X,1H&,66A1)')
cjeh     1               (SFUNCS(IB),IB=JJ,JJ+65)
 30               CONTINUE
            ENDIF
            WRITE(UNIT=SYSPRG,FMT=
     1       '(6X,18HF=LOG(MAX(1.D-8,P(,I2,1H,,I2,3H))))') J,I
            WRITE(UNIT=SYSPRG,FMT='(6X,A)') 'GO TO 9999'
            NCOUNT=NCOUNT+OBS(J,I)
 25         CONTINUE
 24      IF(NCOUNT.NE.N(I)) THEN
            CALL ERROR('BMDPAR -- Error in algebraic expressions.')
         ENDIF
 22      CONTINUE
       WRITE(UNIT=SYSPRG,FMT='(A)') ' 9999 X(4)=F+1.0'
       WRITE(UNIT=SYSPRG,FMT='(6X,A)') 'XLOSS=-F*X(3)'
       WRITE(UNIT=SYSPRG,FMT='(6X,A)') 'RETURN'
       WRITE(UNIT=SYSPRG,FMT='(6X,A)') 'END'
       WRITE(UNIT=SYSPRG,FMT='(6X,A)')
     1   'DOUBLE PRECISION FUNCTION SUM(X,N)'
       WRITE(UNIT=SYSPRG,FMT='(6X,A)')
     1   'DOUBLE PRECISION X(*)'
       WRITE(UNIT=SYSPRG,FMT='(6X,A)')
     1   'INTEGER N,I'
       WRITE(UNIT=SYSPRG,FMT='(6X,A)') 'SUM=X(1)'
       WRITE(UNIT=SYSPRG,FMT='(6X,A)')
     1   'IF (N.GT.1) THEN'
       WRITE(UNIT=SYSPRG,FMT='(6X,A)')
     1   '   DO 10 I=2,N'
       WRITE(UNIT=SYSPRG,FMT='(A)')
     1   ' 10         SUM=SUM+X(I)'
       WRITE(UNIT=SYSPRG,FMT='(6X,A)') 'ENDIF'
       WRITE(UNIT=SYSPRG,FMT='(6X,A)') 'RETURN'
       WRITE(UNIT=SYSPRG,FMT='(6X,A)') 'END'
      CLOSE(UNIT=SYSPRG,STATUS='keep')
C
C   DETERMINE THE NUMBER OF BMDPAR CONSTRAINTS TO
C   PRINT ON THE / REGRESSION PARAGRAPH.
C
       NBMDCT=0
       DO 80 I=1,NPAR
          IF (POINTL(I).NE.0) THEN
             NBMDCT=NBMDCT+1
          ENDIF
          IF (POINTU(I).NE.0) THEN
             NBMDCT=NBMDCT+1
          ENDIF
 80       CONTINUE
C
C   OPEN UP OUTPUT FILE FOR BMDPAR INPUT COMMANDS
C
      OPEN(UNIT=SYSPRG,FILE='bmdinp.d',STATUS='unknown')
      REWIND(UNIT=SYSPRG)
       WRITE(UNIT=SYSPRG,FMT='(A)') '/ PROBLEM   TITLE IS '''//
     1 TITSTR(1:NONBLK(TITSTR,LEN(TITSTR)))//'''.'
       WRITE(UNIT=SYSPRG,FMT='(A)')
     1 '/ INPUT     VARIABLES ARE 4.'
       WRITE(UNIT=SYSPRG,FMT='(12X,A)')
     1 'FORMAT IS ''(4F10.0)''.'
       WRITE(UNIT=SYSPRG,FMT='(A)')
     1 '/ VARIABLES NAMES ARE COHORT,CLASS,OBSERVED,DUMMY.'
       WRITE(UNIT=SYSPRG,FMT='(A)')
     1 '/ REGRESS   DEPENDENT IS DUMMY.'
       WRITE(UNIT=SYSPRG,FMT='(12X,A,I3,A)')
     1 'PARAMETERS ARE ',NPAR,'.'
       WRITE(UNIT=SYSPRG,FMT='(12X,A)')
     1 'WEIGHT IS OBSERVED.'
       WRITE(UNIT=SYSPRG,FMT='(12X,A)')
     1 'MEANSQUARE IS 1.0.'
       WRITE(UNIT=SYSPRG,FMT='(12X,A)')
     1 'LOSS.'
       WRITE(UNIT=SYSPRG,FMT='(12X,A,I5,A)')
     1 'ITER=',NPAR*40,'.'
       WRITE(UNIT=SYSPRG,FMT='(12X,A)')
     1 'CONV=0.0000001.'
       IF (NBMDCT.GT.0) THEN
          WRITE(UNIT=SYSPRG,FMT='(12X,A,I2,A)')
     1      'CONSTRAINTS ARE ',NBMDCT,'.'
       ENDIF
       WRITE(UNIT=SYSPRG,FMT='(A,14(A1,I2.2,A1)/20(A1,I2.2,A1)/
     1   20(A1,I2.2,A1)/20(A1,I2.2,A1)/20(A1,I2.2,A1)/20(A1,I2.2,A1))')
     1 '/ PARAMETER NAMES ARE ',('S',I,',',I=1,NPAR-1),
     2 'S',NPAR,'.'
       WRITE(UNIT=SYSPRG,FMT='(12X,A,10(F4.2,A1)/16(F4.2,A1)/
     1      16(F4.2,A1)/16(F4.2,A1)/16(F4.2,A1)/16(F4.2,A1))')
     1 'INITIAL ARE ',(PAR(I),',',I=1,NPAR-1),
     2 PAR(NPAR),'.'
       WRITE(UNIT=SYSPRG,FMT='(12X,A,10(F4.2,A1)/16(F4.2,A1)/
     1      16(F4.2,A1)/16(F4.2,A1)/16(F4.2,A1)/16(F4.2,A1))')
     1 'MAXIMUM ARE ',(PARU(I),',',I=1,NPAR-1),
     2 PARU(NPAR),'.'
       WRITE(UNIT=SYSPRG,FMT='(12X,A,10(F4.2,A1)/16(F4.2,A1)/
     1      16(F4.2,A1)/16(F4.2,A1)/16(F4.2,A1)/16(F4.2,A1))')
     1 'MINIMUM ARE ',(PARL(I),',',I=1,NPAR-1),
     2 PARL(NPAR),'.'
       IF (NFIX.GT.0) THEN
          LINE='FIXED ARE '
          NXTCHR=11
          DO 75 I=1,NPAR
             IF (POINT(I).LT.0) THEN
                IF (NXTCHR+3.GT.LEN(LINE)) THEN
                   CALL ERROR('BMDPAR -- Too many fixed parameters.')
                ENDIF
                LINE(NXTCHR:NXTCHR)='S'
                LINE(NXTCHR+1:NXTCHR+1)=DIGIT(I/10)
                LINE(NXTCHR+2:NXTCHR+2)=DIGIT(I-(I/10)*10)
                LINE(NXTCHR+3:NXTCHR+3)=','
                NXTCHR=NXTCHR+4
             ENDIF
 75          CONTINUE
          LINE(NXTCHR-1:NXTCHR-1)='.'
          WRITE(UNIT=SYSPRG,FMT='(12X,A)') LINE(1:NXTCHR-1)
       ENDIF
       IF (NBMDCT.GT.0) THEN
          DO 85 I=1,NPAR
             IF (POINTL(I).NE.0) THEN
                WRITE(UNIT=SYSPRG,FMT=
     1          '(12X,A,1H(,I2,5H)1.,(,I2,6H)-1.0.)')
     2            'CONSTRAINT IS ',POINTL(I),POINT(I)
                WRITE(UNIT=SYSPRG,FMT='(12X,A)')
     1          'LIMIT IS (2)0.0.'
             ENDIF
             IF (POINTU(I).NE.0) THEN
                WRITE(UNIT=SYSPRG,FMT=
     1          '(12X,A,1H(,I2,5H)1.,(,I2,6H)-1.0.)')
     2            'CONSTRAINT IS ',POINT(I),POINTU(I)
                WRITE(UNIT=SYSPRG,FMT='(12X,A)')
     1          'LIMIT IS (2)0.0.'
             ENDIF
 85          CONTINUE
       ENDIF
       WRITE(UNIT=SYSPRG,FMT='(A)') '/ END'
       DO 65 I=1,NCOHT
          DO 70 J=1,NCLASS(I)
             WRITE(UNIT=SYSPRG,FMT='(2(I9,1H.),2F10.3)')
     1            I,J,OBS(J,I),OBS(J,I)
 70       CONTINUE
 65    CONTINUE
       BMDCAL=.FALSE.
       RETURN
       END

