C     SUBROUTINE CSPOOL PERFORMS POOLING OF CHI-SQUARE TABLES
      SUBROUTINE CSPOOL(OBSERV,EXPECT,NDF,NCELL,CHISQ)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION OBSERV(1), EXPECT(1), CHISQ
      INTEGER NDF, NCELL, MP, ML, MU, I, IPL
C   OBSERV  - ARRAY OF OBSERVED CELL FREQUENCIES
C   EXPECT  - ARRAY OF EXPECTED CELL FREQUENCIES
C   NDF    - NUMBER OF DEGREES OF FREEDOM IN TABLE
C            (UNITY SUBSTRACTED EACH TIME TWO CELLS ARE POOLED)
C   NCELL  - NUMBER OF CELLS IN TABLE, OR LENGTH OF OBSERV AND EXPECT
C   CHISQ  - CALCULATED CHI-SQUARE STATISTIC AFTER POOLING
C
      CHISQ=0.
      MU=NCELL
C   FIND THE MINIMUM EXPECTED VALUE, AND POOL WITH SMALLEST NEIGHBOR
 10   ML=1
      DO 20 I=2,MU
         IF (EXPECT(ML).GT.EXPECT(I)) THEN
            ML=I
         ENDIF
 20      CONTINUE
      IF (MU.GT.2 .AND. EXPECT(ML).LT.2. .AND. NDF.GT.1) THEN
         IF (ML.EQ.1) THEN
            MP=2
         ELSEIF (ML.EQ.MU) THEN
            MP=MU-1
         ELSE
            IF (EXPECT(ML-1).GT.EXPECT(ML+1)) THEN
               MP=ML+1
            ELSE
               MP=ML-1
            ENDIF
         ENDIF
C ------- BUG FIX 6/19/91, Heidi Chen
         IPL=MIN(MP,ML)
         EXPECT(IPL)=EXPECT(MP)+EXPECT(ML)
         OBSERV(IPL)=OBSERV(MP)+OBSERV(ML)
         DO 40 I=MAX(MP,ML),MU-1
            EXPECT(I)=EXPECT(I+1)
 40         OBSERV(I)=OBSERV(I+1)
C ------- END BUG FIX 6/19/91, Heidi Chen
         MU=MU-1
         NDF=NDF-1
         GO TO 10
      ELSE
C   CALCULATE CHI-SQUARE STATISTIC
         DO 50 I=1,MU,1
            IF (EXPECT(I).GT.0.) THEN
               CHISQ=CHISQ+(OBSERV(I)-EXPECT(I))**2/EXPECT(I)
            ENDIF
 50         CONTINUE
         RETURN
      ENDIF
      END
