C  *DECK DLGAMA
      DOUBLE PRECISION FUNCTION DLGAMA (ARG)
C
C     THIS ROUTINE FOR COMPUTING DLGAMA IS BASED ON THE ALGOL ROUTINE
C     IN ACM ALGORITHM NUMBER 291.  THE SIGNIFICANT CHANGES ARE THE
C     TRUNCATION OF THE ARGUMENT TO THE RANGE 1.E-35 THRU 1.E+30,
C     TAKING THE LOG OF LOCAL VARIABLE *F* EVEN WHEN THE ARGUMENT
C     IS GREATER THAN OR EQUAL TO 7, AND HANDLING ARGUMENT VALUES
C     LARGER THAN 1.E10 AS IN THE SSP ROUTINE TO AVOID EXPONENT
C     OVERFLOW.
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION ARG
      DOUBLE PRECISION ALNG, F, Z, X
C
      X=ARG
C
C     **CHECK MAGNITUDE OF ARGUMENT
C
      IF (X.LT.1.E10) GO TO 10
C
C     **AVOID LARGISH ARGUMENT
C
      X=MIN(X,1.D30)
      ALNG=X*(LOG(X)-1.)
      GO TO 40
C     ELSE
   10 CONTINUE
C
C     **AVOID SMALLISH ARGUMENT
C
      X=MAX(X,1.D-35)
C
C     **ALGORITHM 291 STARTS HERE
C
      F=1.
C     DO WHILE
   20 IF (X.GE.7.) GO TO 30
      F=F*X
      X=X+1.
      GO TO 20
C     ENDDO
   30 CONTINUE
      F=-LOG(F)
      Z=1./(X*X)
      ALNG=F+(X-0.5)*LOG(X)-X+.918938533204673+(((-.000595238095238*Z+.
     1 000793650793651)*Z-.002777777777778)*Z+.083333333333333)/X
C     ENDIF
   40 CONTINUE
      DLGAMA=ALNG
C
      RETURN
      END
