      SUBROUTINE IDENTF
      INCLUDE 'STATUS'
      INCLUDE 'MODELC'
      DOUBLE PRECISION PP(MXCLAS,MAXCHT),PPAR(MAXPAR)
      DOUBLE PRECISION BNDL,BNDU,EXPCHG,CHGMAX,CONADD,CONMUL,
     1   PARI,PARJ,XLL,SS,VALUE,DUMMY
      CHARACTER LOWBND*8,UPPBND*8
      COMMON /NOLABL/ PPAR,PP,DUMMY(NSPACE)
      INTEGER IVALUE,I,J,II,JJ,K1,K2
      EXTERNAL EST,IVALUE,VALUE,SS
      NOTRAN=.TRUE.
      SINTRN=.FALSE.
      CONMUL=1.05
      CONADD=0.05
C     TAKE CARE OF INFORMATION ON PROC CARD.
      DO 2 I=3,LSTWRD
         IF (WORDS(I).EQ.'ADD') THEN
            CONADD = VALUE(WORDS(I+2))
         ELSE IF (WORDS(I).EQ.'MULTIPLY') THEN
            CONMUL = VALUE(WORDS(I+2))
         ENDIF
    2    CONTINUE
C     INITIAL PARAMETERS AND THEIR BOUNDS
      DO 4 I=1,NPAR
         PAR(I)=0.5
         PARL(I)=0.
         PARU(I)=1.
         POINT(I)=I
         POINTL(I)=0
    4    POINTU(I)=0
      NCONS=0
      NFIX=0
      NEST=NPAR
      CALL GETCMD
    5 IF (WORDS(1).EQ.'CONSTRAINT') THEN
         INDENT=2
         CALL CONSRT(1)
      ELSE IF (WORDS(1).EQ.'INITIAL') THEN
         INDENT=2
         CALL INITAL
      ELSE IF (WORDS(1).EQ.'PROC') THEN
         GO TO 10
      ELSE
         CALL ERROR('Unrecognized command after PROC ESTIMATE.')
         RETURN
      ENDIF
      GO TO 5
 10   INDENT=1
      CALL LINCHK(12)
      WRITE (UNIT=SYSOUT,FMT=
     1   '(/6X,33HNumber of parameters in model  = ,I2)') NPAR
      WRITE (UNIT=SYSOUT,FMT=
     1   '(/6X,33HNumber of parameters set equal = ,I2)') NCONS
      WRITE (UNIT=SYSOUT,FMT=
     1   '(/6X,33HNumber of parameters fixed     = ,I2)') NFIX
      WRITE (UNIT=SYSOUT,FMT=
     1   '(/6X,33HNumber of parameters estimated = ,I2)') NEST
      WRITE(UNIT=SYSOUT,FMT=
     1   '(/6X,33HConstant added or subtracted   = ,F6.4)') CONADD
      WRITE(UNIT=SYSOUT,FMT=
     1   '(/6X,33HConstant multiplied or divided = ,F6.4)') CONMUL
      CALL LINCHK(7+NPAR)
      WRITE(UNIT=SYSOUT,FMT='(////31X,14HLower    Upper)')
      WRITE(UNIT=SYSOUT,FMT=
     1  '(5X,47H  I   Parameter   S(I)    Bound    Bound  Label)')
      WRITE(UNIT=SYSOUT,FMT='(6X,3H---,2X,9(1H-),2X,6(1H-),2X,
     1 1X,5(1H-),4X,5(1H-),2X,20(1H-))')
      CALL MOVFLT(PAR,PPAR,NPAR)
C
C   LOOP TO PRINT INITIAL CONDITIONS
C
      DO 20 I=1,NPAR
         IF (POINTL(I).GT.0) THEN
            WRITE(LOWBND,FMT='(3X,2HS(,I2.2,1H))') POINTL(I)
            BNDL=PAR(POINTL(I))
         ELSE
            WRITE(LOWBND,FMT='(F8.3)') PARL(ABS(POINT(I)))
            BNDL=PARL(ABS(POINT(I)))
         ENDIF
         IF (POINTU(I).GT.0) THEN
            WRITE(UPPBND,FMT='(3X,2HS(,I2.2,1H))') POINTU(I)
            BNDU=PAR(POINTU(I))
         ELSE
            WRITE(UPPBND,FMT='(F8.3)') PARU(ABS(POINT(I)))
            BNDU=PARU(ABS(POINT(I)))
         ENDIF
         WRITE(UNIT=SYSOUT,FMT='(5X,I3,5X,I3,3X,F8.3,1X,2(A8,1X),1X,A)')
     1      I,POINT(I),PAR(ABS(POINT(I))),LOWBND,UPPBND,SLABEL(I)
         IF (BNDL.GT.BNDU .OR. BNDL.GT.PAR(ABS(POINT(I)))
     1      .OR. BNDU.LT.PAR(ABS(POINT(I)))) THEN
            CALL WARN(
     1      'BOUNDARY ERROR -- VALUE RESET TO 0 < S(I) < 1.')
            POINTL(I)=0
            POINTU(I)=0
            PARL(ABS(POINT(I)))=0.
            PARU(ABS(POINT(I)))=1.
         ENDIF
   20    CONTINUE
C
C   LOOP TO SET VALUES OF PAR TO REFLECT BOUNDARIES
C   BUGS -- THIS LOOP DOES NOT HANDLE CONSTRAINTS OF THE TYPE
C           S(I) < S(J) PROPERLY
C
      IF (.NOT.NOTRAN) THEN
         DO 17 I=1,NEST
            DO 18 J=1,NPAR
               IF (POINT(J).EQ.I) GO TO 19
 18            CONTINUE
            CALL ERROR('ESTIM code error 1')
 19         IF (POINTL(J).GT.0) THEN
               BNDL=PAR(POINTL(J))
            ELSE
               BNDL=PARL(POINT(J))
            ENDIF
            IF (POINTU(J).GT.0) THEN
               BNDU=PAR(POINTU(J))
            ELSE
               BNDU=PARU(POINT(J))
            ENDIF
            IF (SINTRN) THEN
               PPAR(I)=ASIN(((PAR(I)-BNDL)/(BNDU-BNDL)-0.5)*2.0)
            ELSE
               PPAR(I)=(PAR(I)-BNDL)/(BNDU-BNDL)
            ENDIF
 17         CONTINUE
         CALL MOVFLT(PPAR,PAR,NEST)
      ENDIF
      IF (DEBUG) THEN
         CALL LINCHK(2)
         CALL WARN('DEBUG output follows.')
         CALL LINCHK(NPAR/5+2)
         WRITE(UNIT=SYSOUT,FMT='(/6X,5H  I =,5(6X,I3,6X),
     1      10(:/11X,5(6X,I3,6X)))') (I,I=1,NPAR)
         CALL LINCHK(NPAR/5+2)
         WRITE(UNIT=SYSOUT,FMT='(/6X,5HPAR =,5G15.8,10(:/11X,5G15.8))')
     1      (PAR(I),I=1,NPAR)
         CALL LINCHK(NPAR/5+2)
         WRITE(UNIT=SYSOUT,FMT='(/6X,5HPARL=,5G15.8,10(:/11X,5G15.8))')
     1      (PARL(I),I=1,NPAR)
         CALL LINCHK(NPAR/5+2)
         WRITE(UNIT=SYSOUT,FMT='(/6X,5HPARU=,5G15.8,10(:/11X,5G15.8))')
     1      (PARU(I),I=1,NPAR)
         CALL LINCHK(NPAR/5+2)
         WRITE(UNIT=SYSOUT,FMT='(/6X,5HS(I)=,5G15.8,10(:/11X,5G15.8))')
     1      (SS(I),I=1,NPAR)
         CALL LINCHK(NPAR/33+2)
         WRITE(UNIT=SYSOUT,FMT='(/6X,7H    I =,33I3,5(:/13X,33I3))')
     1      (I,I=1,NPAR)
         CALL LINCHK(NPAR/33+2)
         WRITE(UNIT=SYSOUT,FMT='(/6X,7HPOINT =,33I3,5(:/13X,33I3))')
     1      (POINT(I),I=1,NPAR)
         CALL LINCHK(NPAR/33+2)
         WRITE(UNIT=SYSOUT,FMT='(/6X,7HPOINTL=,33I3,5(:/13X,33I3))')
     1      (POINTL(I),I=1,NPAR)
         CALL LINCHK(NPAR/33+2)
         WRITE(UNIT=SYSOUT,FMT='(/6X,7HPOINTU=,33I3,5(:/13X,33I3))')
     1      (POINTU(I),I=1,NPAR)
         CALL LINCHK(2)
         CALL WARN('End of DEBUG output.')
      ENDIF
C
C   SET CELL PROBABILITIES IN PP TO CELL PROBABILITIES FOR
C   INITIAL PARAMETER VALUES
C
      CALL EST(NEST,PPAR,XLL)
      CALL MOVFLT(P,PP,MXCLAS*MAXCHT)
C
C   EVERYTHING IS NOW IDENTICAL, SO START MANIPULATING PAR TO
C   SEE IF CELL PROBABILITIES STAY THE SAME
C
C   FIRST CHECK FOR NO CHANGES WHEN A CONSTANT IS ADDED AND
C   SUBTRACTED FROM A PAIR OF PARAMETERS
C
      CHGMAX=1.0
      II=0
      JJ=0
      DO 21 I=1,NPAR-1
         DO 21 J=I+1,NPAR
            PARI=PPAR(I)
            PPAR(I)=PPAR(I)+CONADD
            PARJ=PPAR(J)
            PPAR(J)=PPAR(J)-CONADD
            CALL EST(NEST,PPAR,XLL)
            EXPCHG=0.
            DO 22 K1=1,NCOHT
               DO 22 K2=1,NCLASS(K1)
                  IF (ABS(PP(K2,K1)-P(K2,K1)).GT.EXPCHG) THEN
                     EXPCHG=ABS(PP(K2,K1)-P(K2,K1))
                  ENDIF
 22               CONTINUE
            PPAR(I)=PARI
            PPAR(J)=PARJ
            IF (EXPCHG.LT.CHGMAX) THEN
               CHGMAX=EXPCHG
               II=I
               JJ=J
            ENDIF
 21         CONTINUE
C
C   WRITE TO OUTPUT THE MINIMUM CHANGE OBSERVED FOR A PAIR OF PARAMETERS
C
      WRITE(UNIT=SYSOUT,FMT='(/1X,A,G14.8,A,I2,A,I2,1H.)')
     1 'The minimum maximum change observed was ',CHGMAX,
     2 ' for parameters ',II,' and ',JJ
C   NOW CHECK FOR NO CHANGES WHEN A CONSTANT IS MULTIPLIED AND
C   DIVIDED FOR A PAIR OF PARAMETERS
C
      CHGMAX=1.0
      II=0
      JJ=0
      DO 31 I=1,NPAR-1
         DO 31 J=I+1,NPAR
            PARI=PPAR(I)
            PPAR(I)=PPAR(I)*CONMUL
            PARJ=PPAR(J)
            PPAR(J)=PPAR(J)/CONMUL
            CALL EST(NEST,PPAR,XLL)
            EXPCHG=0.
            DO 32 K1=1,NCOHT
               DO 32 K2=1,NCLASS(K1)
                  IF (ABS(PP(K2,K1)-P(K2,K1)).GT.EXPCHG) THEN
                     EXPCHG=ABS(PP(K2,K1)-P(K2,K1))
                  ENDIF
 32               CONTINUE
            PPAR(I)=PARI
            PPAR(J)=PARJ
            IF (EXPCHG.LT.CHGMAX) THEN
               CHGMAX=EXPCHG
               II=I
               JJ=J
            ENDIF
 31         CONTINUE
C
C   WRITE TO OUTPUT THE MINIMUM CHANGE OBSERVED FOR A PAIR OF PARAMETERS
C
      WRITE(UNIT=SYSOUT,FMT='(/1X,A,G14.8,A,I2,A,I2,1H.)')
     1 'The minimum maximum change observed was ',CHGMAX,
     2 ' for parameters ',II,' and ',JJ
      RETURN
      END
