C  *DECK SAMSZ2
      SUBROUTINE SAMSZ2
C
C   THIS SUBROUTINE PERFORMS SAMPLE SIZE CALCULATIONS BASED ON
C   THE SURVIVAL MODELS IN BROWNIE ET AL. 1976, PAGES 186-193
C
      INCLUDE 'STATUS'
      DOUBLE PRECISION SBARA(0:3),SPBARA(0:3),CVSA(0:3),CVSPA(0:3),
     1                 FBARA(0:3)
      DOUBLE PRECISION SBAR,SPBAR,FBAR,CVSP,CVS
      DOUBLE PRECISION VALUE
      INTEGER KA(3)
      INTEGER*4 I,K,N,M
      INTEGER NLINES
      INTEGER IVALUE
      EXTERNAL VALUE,IVALUE
      CHARACTER*81 HEAD
      DATA NLINES/0/
      DATA HEAD/'    S-BAR    S''-BAR     F-BAR     CV(S)    CV(S'')
     +    K         N         M'/
C   THE FOLLOWING COMMENTED FORTRAN STATEMENTS GENERATE THE EXAMPLE
C   IN BROWNIE ET AL. PAGES 186-193
C     CALL SAMSIZ(0.6,0.5,0.07,0.04,5,N,M)
C     PRINT *,N,M
      DO 10 I=0,2
         SBARA(I)=0.5
         SPBARA(I)=0.5
         FBARA(I)=0.9
         CVSA(I)=0.05
         CVSPA(I)=0.05
         KA(I)=5
   10    CONTINUE
         SBARA(3)=0.1
         SPBARA(3)=0.1
         FBARA(3)=0.05
         CVSA(3)=0.01
         CVSPA(3)=0.01
         KA(3)=1
   20 CALL GETCMD
      INDENT=2
      IF (WORDS(1).EQ.'S-BAR') THEN
         DO 21 I=1,3
            IF (WORDS(I+2).NE.' ') THEN
               SBARA(I)=VALUE(WORDS(I+2))
            ELSE
               SBARA(I)=SBARA(I-1)
            ENDIF
   21       CONTINUE
      ELSE IF (WORDS(1).EQ.'S''-BAR') THEN
         DO 22 I=1,3
            IF (WORDS(I+2).NE.' ') THEN
               SPBARA(I)=VALUE(WORDS(I+2))
            ELSE
               SPBARA(I)=SPBARA(I-1)
            ENDIF
   22       CONTINUE
      ELSE IF (WORDS(1).EQ.'F-BAR') THEN
         DO 23 I=1,3
            IF (WORDS(I+2).NE.' ') THEN
               FBARA(I)=VALUE(WORDS(I+2))
            ELSE
               FBARA(I)=FBARA(I-1)
            ENDIF
   23       CONTINUE
      ELSE IF (WORDS(1).EQ.'CV(S)') THEN
         DO 24 I=1,3
            IF (WORDS(I+2).NE.' ') THEN
               CVSA(I)=VALUE(WORDS(I+2))
            ELSE
               CVSA(I)=CVSA(I-1)
            ENDIF
   24       CONTINUE
      ELSE IF (WORDS(1).EQ.'CV(S'')') THEN
         DO 25 I=1,3
            IF (WORDS(I+2).NE.' ') THEN
               CVSPA(I)=VALUE(WORDS(I+2))
            ELSE
               CVSPA(I)=CVSPA(I-1)
            ENDIF
   25       CONTINUE
      ELSE IF (WORDS(1).EQ.'K') THEN
         DO 26 I=1,3
            IF (WORDS(I+2).NE.' ') THEN
               KA(I)=IVALUE(WORDS(I+2))
            ELSE
               KA(I)=KA(I-1)
            ENDIF
   26       CONTINUE
      ELSE IF (WORDS(1).EQ.'PROC') THEN
         INDENT=1
         CALL LINCHK(14)
         WRITE(UNIT=SYSOUT,FMT=100)
      DO 31 SBAR=SBARA(1),SBARA(2),SBARA(3)
         DO 32 SPBAR=SPBARA(1),SPBARA(2),SPBARA(3)
            DO 33 FBAR=FBARA(1),FBARA(2),FBARA(3)
               DO 34 CVS=CVSA(1),CVSA(2),CVSA(3)
                  DO 35 CVSP=CVSPA(1),CVSPA(2),CVSPA(3)
                     DO 36 K=KA(1),KA(2),KA(3)
                        CALL SAMSIZ(SBAR,SPBAR,FBAR,CVS,CVSP,K,N,M)
                        NLINES=NLINES+1
                        IF (MOD(NLINES,50).EQ.1) THEN
                           CALL HEADNG
                           WRITE(UNIT=SYSOUT,FMT='(//A)') HEAD
                           WRITE(UNIT=SYSOUT,FMT='(79A1/)')
     1                      ' ',('-',I=1,78)
                        ENDIF
                        WRITE(UNIT=SYSOUT,FMT='(1X,F8.2,4F10.2,3I10)')
     1                    SBAR,SPBAR,FBAR,CVS,CVSP,K,N,M
   36                   CONTINUE
   35                CONTINUE
   34             CONTINUE
   33          CONTINUE
   32       CONTINUE
   31    CONTINUE
         CALL HEADNG
         RETURN
      ELSE
         CALL ERROR('Unrecognized command after PROC SAMPLE SIZE.')
         RETURN
      ENDIF
      GO TO 20
  100 FORMAT('0',5X,'SAMPLE SIZE ESTIMATION FOLLOWING BROWNIE ET AL. 198
     15:190-193'//
     26X,'NOTATION   INTERPRETATION'/
     36X,8('-'),3X,54('-')/
     46X,' S-BAR     Mean adult survival rate per year'/
     56X,' S''-BAR    Mean young survival rate per year'/
     66X,' F-BAR     Mean adult recovery rate per year'/
     76X,' CV(S)     Coefficient of variation of mean adult survival rat
     8e'/
     96X,' CV(S'')    Coefficient of variation of mean young survival ra
     Ate'/
     B6X,'   K       Number of years to conduct banding effort'/
     C6X,'   M       Number of young to band each year'/
     D6X,'   N       Number of adults to band each year')
      END
