C
C   SURVIV IS A FORTRAN 77 PROGRAM TO ESTIMATE SURVIVAL RATES
C   FROM A USER SPECIFIED MODEL.
C   THIS SOURCE TO BE COMPILED ON THE UNIX OPERATING SYSTEM
C
      PROGRAM SURVIV
      INCLUDE 'STATUS'
      INCLUDE 'HEADST'
      INCLUDE 'MODELC'
      CHARACTER FILEIN*60,FILOUT*60,ENDSTR*40
      INTEGER IVALUE
      EXTERNAL IVALUE
      INTEGER I
      CHARACTER*40 XEQLIN(20)
      INTEGER NARG
C
C   SET UP UNLABELED COMMON AS TEMPORARY STORAGE
C
      COMMON /NOLABL/ DUMMY(MAXCM)
C
      DATA ENDSTR/'E X E C U T I O N   S U C C E S S F U L'/
      IF (MAXPAR.LT.11) THEN
         CALL ERROR('MAXPAR < 11.  '//
     2   'Recompile with new PARAMETERs.')
      ENDIF
      IF (MAXCHT*MXCLAS.LT.MAXPAR)
     1   CALL ERROR('MAXCHT*MXCLAS < MAXPAR.  '//
     2   'Recompile with new PARAMETERs.')
      SYSIN=5
      SYSOUT=6
      SYSPRG=2
      SYSTP1=8
      SYSTP2=1
      EOF=.FALSE.
      MODFLG=.FALSE.
      NXTCHR=1
      LSTCHR=0
      LCMDST=1
      LCMDED=0
      NPAGE=0
      LINES=0
      MAXLIN=9999
      TITSTR=' '
      VERSON='Version 2.0(WIN)     Oct. 1999'
      CPLFLG=.FALSE.
      DETAIL=.TRUE.
      SIMULT=.FALSE.
      BMDCAL=.FALSE.
      NOECHO=.FALSE.
      FILEIN = ' '
      FILOUT = ' '
      CALL DATER(DATSTR,TIMSTR)
      narg=iargc()
c      narg=nargs()
c      print *,'narg=',narg
      if(narg.le.1) then
        CALL ARGS(NARG,XEQLIN)
      else
         do i=1,narg
            call getarg(i,xeqlin(i))
c            print *,i,xeqlin(i)
         end do
      end if
      DO 1 I=1,NARG
         IF (XEQLIN(I)(1:2).EQ.'I=') FILEIN=XEQLIN(I)(3:40)
         IF (XEQLIN(I)(1:2).EQ.'i=') FILEIN=XEQLIN(I)(3:40)
         IF (XEQLIN(I)(1:2).EQ.'L=') FILOUT=XEQLIN(I)(3:40)
         IF (XEQLIN(I)(1:2).EQ.'l=') FILOUT=XEQLIN(I)(3:40)
         IF (XEQLIN(I)(1:7).EQ.'COMPILE') CPLFLG=.TRUE.
         IF (XEQLIN(I)(1:7).EQ.'compile') CPLFLG=.TRUE.
         IF (XEQLIN(I)(1:6).EQ.'NOECHO') NOECHO=.TRUE.
         IF (XEQLIN(I)(1:6).EQ.'noecho') NOECHO=.TRUE.
         IF (XEQLIN(I)(1:6).EQ.'LINES=') MAXLIN=IVALUE(XEQLIN(I)(7:16))
         IF (XEQLIN(I)(1:6).EQ.'lines=') MAXLIN=IVALUE(XEQLIN(I)(7:16))
 1       CONTINUE
 5    CONTINUE
      IF (MAXLIN.LT.30) THEN
         CALL WARN ('Lines per page set to 60.')
         MAXLIN=60
      ENDIF
      IF (FILEIN.NE.' ') THEN
         SYSIN=4
         OPEN(UNIT=SYSIN,FILE=FILEIN,STATUS='OLD',ERR=30)
         REWIND(UNIT=SYSIN)
      ENDIF
      IF (FILOUT.NE.' ') THEN
         OPEN(UNIT=SYSOUT,FILE=FILOUT,STATUS='UNKNOWN')
         REWIND(UNIT=SYSOUT)
      ENDIF
      CALL FILLSG
      CALL GETCMD
      TCUMUL=0.0
      TSTART=SECNDS(0.0)
      CALL LINCHK(9)
      WRITE (SYSOUT,'(/6X,A)') 'Dimension limitations for this run:'
      WRITE (SYSOUT,'(8X,A,T50,I4)')
     1   'Maximum number of parameters',MAXPAR
      WRITE (SYSOUT,'(8X,A,T50,I4)')
     1   'Maximum number of estimable parameters',MXPAR3
      WRITE (SYSOUT,'(8X,A,T50,I4)')
     1   'Maximum number of cohorts',MAXCHT
      WRITE (SYSOUT,'(8X,A,T50,I4)')
     1   'Maximum number of classes within a cohort',MXCLAS
      WRITE (SYSOUT,'(8X,A,T50,I4)')
     1   'Maximum number of models for PROC TEST',MAXMOD
      WRITE (SYSOUT,'(6X,A)')
     1 'If your problem needs larger dimensions, reset the values'
      WRITE (SYSOUT,'(6X,A/)')
     1 'in the MODELC include file and recompile the program.'
      CALL LINCHK(5)
      WRITE (SYSOUT,'(2X,A)')
     1 'Date       Modifications'
      WRITE (SYSOUT,'(2X,A)')
     1 '---------  '//
     2'----------------------------------------------------------------'
      WRITE (SYSOUT,'(2X,A)')
     1 'March, 90  '//
     2'NORMALIZE option for PROC MODEL to normalize cell probabilities.'
      WRITE (SYSOUT,'(2X,A)')
     1 'March, 90  '//
     2'ADDCELL option for PROC MODEL to add cell with 1 - sum of cells.'
      WRITE (SYSOUT,'(2X,A)')
     1 'March, 90  '//
     2'NOBINCOF option for PROC ESTIMATE to not add bin. coef. to like.'
       WRITE (SYSOUT,'(2X,A)')  ' '
   10 IF(WORDS(1).EQ.'PROC') THEN
         INDENT=1
         IF (WORDS(3).EQ.'DEBUG') THEN
            DEBUG=.TRUE.
         ELSE
            DEBUG=.FALSE.
         ENDIF
         IF (LINES .LT. 30 ) CALL HEADNG
         IF(WORDS(2).EQ.'MODEL') THEN
            CALL MODEL
         ELSE IF(WORDS(2).EQ.'BROWNIE') THEN
            CALL BROWN
         ELSE IF (WORDS(2).EQ.'ESTIMATE') THEN
            CALL ESTMAT(1)
         ELSE IF (WORDS(2).EQ.'TEST') THEN
            CALL DOTEST
         ELSE IF (WORDS(2).EQ.'SIMULATE') THEN
C            SET FLAG INDICATING PROC SIMULATE HAS BEEN CALLED
            SIMULT=.TRUE.
            CALL SIMLTE
            SIMULT=.FALSE.
         ELSE IF (WORDS(2).EQ.'SAMPLE' .AND. WORDS(3).EQ.'SIZE') THEN
            CALL SAMSZ2
         ELSE IF (WORDS(2).EQ.'TITLE') THEN
            CALL TITLE
         ELSE IF (WORDS(2).EQ.'BMDPAR') THEN
            CALL BMDPAR
         ELSE IF (WORDS(2).EQ.'IDENTIFIAB') THEN
            CALL IDENTF
         ELSE IF (WORDS(2).EQ.'STOP') THEN
            CALL PRTCMD
         WRITE(UNIT=SYSOUT,FMT='(/5X,A,F8.2)')
     1      'CPU time in minutes for this job was',TCUMUL/60.
            WRITE(UNIT=SYSOUT,FMT='(//10X,A)') ENDSTR
            CLOSE(UNIT=SYSIN)
            CLOSE(UNIT=SYSTP1)
            CLOSE(UNIT=SYSTP2)
            CLOSE(UNIT=SYSPRG)
            CLOSE(UNIT=SYSOUT)
            STOP 'SURVIV NORMAL TERMINATION'
         ELSE
            CALL ERROR('Unrecognized procedure specified.')
         ENDIF
      ELSE IF (WORDS(1).EQ.'STOP') THEN
         CALL PRTCMD
         WRITE(UNIT=SYSOUT,FMT='(/5X,A,F8.2)')
     1      'CPU time in minutes for this job was',TCUMUL/60.
         WRITE(UNIT=SYSOUT,FMT='(//10X,A)') ENDSTR
         CLOSE(UNIT=SYSIN)
         CLOSE(UNIT=SYSTP1)
         CLOSE(UNIT=SYSTP2)
         CLOSE(UNIT=SYSPRG)
         CLOSE(UNIT=SYSOUT)
         STOP 'SURVIV NORMAL TERMINATION'
      ELSE
         CALL ERROR('Unrecognized input.')
      ENDIF
      TSTOP=SECNDS(TSTART)
      TSTART=TSTOP+TSTART
      CALL LINCHK(2)
      WRITE(UNIT=SYSOUT,FMT='(/5X,A,F8.2)')
     1   'CPU time in seconds for last procedure was',TSTOP
      TCUMUL=TCUMUL+TSTOP
      GO TO 10
 30   CALL ERROR('Could not open file '//FILEIN//' for input.')
      END
c   args is for use on PC
c   DO NOT associate unit 5 with a file until after args is called
      subroutine args(nargs,xeqlin)
      character*40 xeqlin(20)
      character*150 string,temp
      integer nargs, iblank
      nargs=0
      write(0,*)'Enter command line parameters [i=in_file] [l=out_file]'
      write(0,*)'   [lines=n] [compile run] [noecho]:'
      read(*,'(a)',end=30) string
 10   if (string.eq.' ') return
      call lblksp(string)
      iblank=index(string,' ')
      nargs=nargs+1
      xeqlin(nargs)=string(1:iblank-1)
      temp=string(iblank:150)
      string=temp
      go to 10
 30   return
      end
      subroutine lblksp(string)
      character*(*) string
      if (string(1:1).ne.' ') return
      do 10 i=2,len(string)
          if (string(i:i).ne.' ') go to 20
 10       continue
      return
 20   nonblk=i
      do 30 i=nonblk,len(string)
         ib=i-nonblk+1
         string(ib:ib)=string(i:i)
         string(i:i)=' '
 30      continue
      return
      end
c     double precision function rl(x)
c     double precision x
c     rl=exp(x)/(1.d0+exp(x))
c     return
c     end
      real*8 function rl(i,j,k)
      include 'STATUS'
      integer i,j,k
      include 'MODELC'
      rl=(1.0d0/(1.0d0+exp(-(ss(i)+ss(j)*dble(k)))))
      return
      end

